﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter.Events;

namespace XamDataGridAnimation
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<Person> coll { get; set; }
        public MainWindow()
        {
            InitializeComponent();
            coll = new ObservableCollection<Person>();

            for (int i = 0; i < 100000; i++)
            {
                coll.Add(new Person() { Id = i, LastName = "Smith", Age = 23 });
            }

            coll.Add(new Person() { Id = 1, LastName = "Doe" });
            coll.Add(new Person() { Id = 3, LastName = "Doe", Age = 34343434.5555 });
            coll.Add(new Person() { Id = 2, LastName = "Doe", Age = 56 });
            coll.Add(new Person() { Id = 4, LastName = "Smith", Age = 23 });
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            Dispatcher.BeginInvoke(new Action(() =>
            {
                animation.Visibility = Visibility.Visible;
            }), DispatcherPriority.Send, null);

            Dispatcher.BeginInvoke(new Action(() =>
            {
                xamDataGrid1.DataSource = coll;
            }), DispatcherPriority.SystemIdle, null);
        }

        private void xamDataGrid1_FieldLayoutInitialized(object sender, FieldLayoutInitializedEventArgs e)
        {
            animation.Visibility = Visibility.Collapsed;
        }
    }

    public class Person : INotifyPropertyChanged
    {
        private int id;


        public int Id
        {
            get { return id; }
            set
            {
                id = value;
                NotifyPropertyChanged("Id");
            }
        }

        private double age;

        public double Age
        {
            get { return age; }
            set { age = value; NotifyPropertyChanged("Age"); }
        }

        private String lastName;

        public String LastName
        {
            get { return lastName; }
            set { lastName = value; NotifyPropertyChanged("LastName"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }

        }

    }
}
